import java.awt.*;//for class Point

public class KnightMoves
{
	public static int iHorizontalMove[];
	public static int iVerticalMove[];
	
	public static void init()
	{
		iHorizontalMove = new int[8];
		iVerticalMove = new int[8];
		
		iHorizontalMove[0] = -1;
		iVerticalMove[0] = 2;
		
		iHorizontalMove[1] = -2;
		iVerticalMove[1] = 1;
		
		iHorizontalMove[2] = -2;
		iVerticalMove[2] = -1;
		
		iHorizontalMove[3] = -1;
		iVerticalMove[3] = -2;
		
		iHorizontalMove[4] = 1;
		iVerticalMove[4] = -2;
		
		iHorizontalMove[5] = 2;
		iVerticalMove[5] = -1;
		
		iHorizontalMove[6] = 2;
		iVerticalMove[6] = 1;
		
		iHorizontalMove[7] = 1;
		iVerticalMove[7] = 2;
	}
	
	public static int[] enumerateMoves( Point ptPos )
	{
		if( ( ptPos.x > 7 || ptPos.x < 0 ) ||
			( ptPos.y > 7 || ptPos.y < 0 )
		  )
			return null;
					
		int iMoves[] = new int[8];
		int i, j;
		
		for( i = 0 ; i < 8 ; ++i )
			iMoves[i] = -1;
		
		for( i = 0, j = 0 ; i < 8 ; ++i )
		{	
			int iHorz = ptPos.x + iHorizontalMove[i];
			int iVert = ptPos.y + iVerticalMove[i];
			
			if( ( iHorz < 8 && iHorz >= 0 ) &&
				( iVert < 8 && iVert >= 0 )
			  )
			{
				iMoves[j] = i;
				++j;
			}
		}
				
		return iMoves;
	}
}